# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

_Public Classes_

* [`codimd`](#codimd): Puppet Module to install and configure codiMD

_Private Classes_

* `codimd::config`: Configure CodiMD
* `codimd::install`: Install CodiMD
* `codimd::service`: Startup CodiMD
* `codimd::user`: Configure the CodiMD application user

**Data types**

* [`Codimd::Db`](#codimddb): 
* [`Codimd::Dialect`](#codimddialect): 

## Classes

### codimd

Puppet Module to install and configure codiMD

#### Parameters

The following parameters are available in the `codimd` class.

##### `version`

Data type: `String`

Which version of CodiMD should be installed. Gets passed though to the vcsrepo resource.

Default value: 'master'

##### `config`

Data type: `Hash[String,Data]`

Configuration of CodiMD. Gets place in the "production" hash of the config.json.

## Data types

### Codimd::Db

The Codimd::Db data type.

Alias of `Struct[{
  username => String[1],
  password => String[1],
  database => String[1],
  host     => String[1],
  port     => Stdlib::Port,
  dialect  => Codimd::Dialect,
}]`

### Codimd::Dialect

The Codimd::Dialect data type.

Alias of `Enum['mysql', 'mariadb', 'sqlite', 'postgres', 'mssql']`

